import type { TransitionHookOptions, TransitionHookReturnValue } from "./types";
/**
 * You'll most likely want to use the {@link useCSSTransition} hook instead
 * since this is just a low-level hook that can be used to transition using
 * timeouts.
 *
 * @typeParam E - The HTMLElement type used or the ref required for the
 * transition.
 * @remarks \@since 4.0.0
 */
export declare function useTransition<E extends HTMLElement>({ nodeRef, timeout, transitionIn, reflow, temporary, appear, enter, exit, onEnter, onEntering, onEntered, onExit, onExiting, onExited, }: TransitionHookOptions<E>): TransitionHookReturnValue<E>;
